(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/operators'), require('@angular/router'), require('@angular/common'), require('@angular/material/paginator'), require('@angular/material/sort'), require('@angular/animations'), require('@angular/material/toolbar'), require('@angular/material/icon'), require('@angular/material/button'), require('@angular/material/table'), require('@angular/material/card'), require('@angular/material/form-field')) :
  typeof define === 'function' && define.amd ? define('@yukawa/chain-base-angular-layout', ['exports', '@angular/core', 'rxjs/operators', '@angular/router', '@angular/common', '@angular/material/paginator', '@angular/material/sort', '@angular/animations', '@angular/material/toolbar', '@angular/material/icon', '@angular/material/button', '@angular/material/table', '@angular/material/card', '@angular/material/form-field'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-base-angular-layout'] = {}), global.ng.core, global.rxjs.operators, global.ng.router, global.ng.common, global.ng.material.paginator, global.ng.material.sort, global.ng.animations, global.ng.material.toolbar, global.ng.material.icon, global.ng.material.button, global.ng.material.table, global.ng.material.card, global.ng.material.formField));
}(this, (function (exports, core, operators, router, common, paginator, sort, animations, toolbar, icon, button, table, card, formField) { 'use strict';

  var LayoutComponent = /** @class */ (function () {
      function LayoutComponent() {
      }
      LayoutComponent.prototype.ngOnInit = function () {
      };
      return LayoutComponent;
  }());
  LayoutComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'lib-layout',
                  template: "\n    <p>\n      layout works!\n    </p>\n  "
              },] }
  ];
  /** @nocollapse */
  LayoutComponent.ctorParameters = function () { return []; };

  var TableRowColumnDirective = /** @class */ (function () {
      function TableRowColumnDirective(templateRef) {
          this.templateRef = templateRef;
      }
      return TableRowColumnDirective;
  }());
  TableRowColumnDirective.decorators = [
      { type: core.Directive, args: [{ selector: 'ng-template[rowColumn]' },] }
  ];
  /** @nocollapse */
  TableRowColumnDirective.ctorParameters = function () { return [
      { type: core.TemplateRef }
  ]; };
  TableRowColumnDirective.propDecorators = {
      rowColumn: [{ type: core.Input }]
  };
  var TableContentComponent = /** @class */ (function () {
      function TableContentComponent(router, activatedRoute, location) {
          this.router = router;
          this.activatedRoute = activatedRoute;
          this.location = location;
          this.hasToolbar = true;
          this.hasSearch = true;
          this.hasAddButton = true;
          this.hasBackButton = true;
          this.hasPaginator = true;
          this.tableRowClick = new core.EventEmitter();
      }
      Object.defineProperty(TableContentComponent.prototype, "tableLayoutInput", {
          get: function () {
              return this._tableLayoutInput;
          },
          set: function (tl) {
              this._tableLayoutInput = tl;
          },
          enumerable: false,
          configurable: true
      });
      ;
      Object.defineProperty(TableContentComponent.prototype, "matSort", {
          set: function (ms) {
              this.sort = ms;
          },
          enumerable: false,
          configurable: true
      });
      Object.defineProperty(TableContentComponent.prototype, "matPaginator", {
          set: function (ms) {
              this.paginator = ms;
          },
          enumerable: false,
          configurable: true
      });
      TableContentComponent.prototype.ngOnInit = function () {
          var _this = this;
          this.dataSource = this.tableLayoutInput.dataSource;
          this.dataSource.setPaginator(this.paginator);
          this.dataSource.setSort(this.sort);
          this.tableLayoutInput.columnDef.pipe(operators.map(function (res) { return res.map(function (res) { return res.columnId; }); })).subscribe(function (res) {
              _this.displayedColumns = res;
          });
          this.tableLayoutInput.columnDef.pipe(operators.map(function (res) { return res.map(function (res) { return res.columnName; }); })).subscribe(function (res) {
              _this.columnNames = res;
          });
          if (this.tableLayoutInput.addRoute) {
              this.addRoute = this.tableLayoutInput.addRoute;
          }
          if (this.tableLayoutInput.backRoute) {
              this.backRoute = this.tableLayoutInput.backRoute;
          }
      };
      TableContentComponent.prototype.ngAfterContentInit = function () {
          var columnMap = new Map();
          var refArray = this.rowColumnDirectives.toArray();
          refArray.forEach(function (val) {
              columnMap.set(val.rowColumn, val);
          });
          this.rowColumnTemplates = columnMap;
      };
      TableContentComponent.prototype.getPageSizeOptions = function () {
          return [5, 10, 20, 50, 100, 250];
      };
      TableContentComponent.prototype.getDefaultPageSize = function () {
          var tableFilter = this.dataSource.filterSubject.value;
          if (tableFilter && tableFilter.pager) {
              return tableFilter.pager.pageSize;
          }
          return 250;
      };
      TableContentComponent.prototype.add = function () {
          if (this.addRoute) {
              if (this.addRoute.queryParams) {
                  this.router.navigate([this.addRoute.path], { queryParams: this.addRoute.queryParams });
              }
              else {
                  this.router.navigate([this.addRoute.path]);
              }
          }
          else {
              this.router.navigate(['0'], { relativeTo: this.activatedRoute });
          }
      };
      TableContentComponent.prototype.back = function () {
          if (this.backRoute) {
              if (this.backRoute.queryParams) {
                  this.router.navigate([this.backRoute.path], { queryParams: this.backRoute.queryParams });
              }
              else {
                  this.router.navigate([this.backRoute.path]);
              }
          }
          else {
              this.location.back();
          }
      };
      TableContentComponent.prototype.onRowClick = function (row) {
          this.tableRowClick.emit(row);
      };
      TableContentComponent.prototype.reload = function (filter) {
          filter = Object.assign(Object.assign({}, this.dataSource.filterSubject.value), filter);
          this.dataSource.filterSubject.next(filter);
          return false;
      };
      TableContentComponent.prototype.navigateBack = function () {
          this.location.back();
      };
      return TableContentComponent;
  }());
  TableContentComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'base-table-content',
                  template: "<mat-toolbar *ngIf=\"tableLayoutInput.title\" color=\"accent\" style=\"height:20px; opacity: 0.5\"><span\n  style=\"font-size: 0.7em\">{{tableLayoutInput?.title}}</span></mat-toolbar>\n<!-- =================================  Table search + dynamic filter comp + buttons =============================== -->\n<mat-toolbar style=\"height:90px\" class=\"table-layout-toolbar\" *ngIf=\"hasToolbar\">\n\n  <button mat-mini-fab name=\"cmd\" type=\"button\" (click)='back()' class=\"margin-right--small\" *ngIf=\"hasBackButton\">\n    <mat-icon>arrow_back</mat-icon>\n  </button>\n\n  <ng-container>   <!-- <ng-container *permissionEdit=\"tableLayoutInput.expectedRoles\">-->\n    <button *ngIf=\"!tableLayoutInput.disableAddButton && hasAddButton\" mat-mini-fab name=\"cmd\" type=\"button\"\n            value=\"create\" (click)=\"add()\" class=\"margin-right--small\">\n      <mat-icon>add</mat-icon>\n    </button>\n  </ng-container>\n\n  <!-- TODO fix this -->\n<!--  <button *ngIf=\"tableLayoutInput.downloadable\" mat-mini-fab name=\"excel\" type=\"button\"\n          (click)=\"dataSource.excelExport()\" class=\"margin-right&#45;&#45;small\">\n    <mat-icon>cloud_download</mat-icon>\n  </button>-->\n\n<!--  <table-search [searchFields]=\"tableLayoutInput.advanceSearchCriteria\"\n                [hasAdvanceSearch]=\"tableLayoutInput.advanceSearch\" *ngIf=\"tableLayoutInput.searchable && hasSearch\"\n                (changed)=\"reload($event)\"\n                class=\"margin-right&#45;&#45;small\"></table-search>-->\n\n  <div class=\"spacer\"></div>\n\n\n</mat-toolbar>\n\n<!-- =================================   Further table controls (e.g. tabs)========================================= -->\n\n<ng-content select=\"[controls]\"></ng-content>\n\n<!-- =================================   Paginator ================================================================= -->\n<div>\n  <mat-paginator #paginator [pageSizeOptions]=\"getPageSizeOptions()\">\n  </mat-paginator>\n</div>\n\n<!-- =================================== Mat Table ================================================================= -->\n<table #matTable mat-table [dataSource]=\"dataSource\" matSort\n       matSortActive=\"{{tableLayoutInput.matSortActive}}\" matSortDisableClear\n       matSortDirection=\"{{tableLayoutInput.matSortDirection ? tableLayoutInput.matSortDirection : 'desc'}}\">\n\n  <ng-container *ngFor=\"let column of displayedColumns;let i = index\" [matColumnDef]=\"column\">\n    <th mat-sort-header mat-header-cell *matHeaderCellDef>\n      {{columnNames[i]}}\n    </th>\n    <td mat-cell *matCellDef=\"let row\">\n      <ng-container [ngTemplateOutlet]=\"rowColumnTemplates.get(column)?.templateRef\"\n                    [ngTemplateOutletContext]=\"{$implicit: row}\"></ng-container>\n    </td>\n  </ng-container>\n\n  <tr mat-header-row *matHeaderRowDef=\"displayedColumns\"></tr>\n  <tr mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onRowClick(row)\" class=\"row-click\"></tr>\n</table>\n\n<!-- ===================================== Loading indicator ======================================================= -->\n<mat-card fxLayout=\"row\" *ngIf=\"dataSource.status == 'loading'\" fxLayoutAlign=\"center\">\n  <!-- TODO extract loading indicator component to library <app-loading-indicator></app-loading-indicator>-->\n</mat-card>\n\n<!-- ===================================== Table empty ============================================================= -->\n<mat-card *ngIf=\"dataSource?.dataSubject?.value?.length === 0\" fxLayoutAlign=\"center\">\n  <span><!-- TODO should be configured as input prop -->Die Tabelle hat noch keine Eintr\u00E4ge!</span>\n</mat-card>\n\n<!-- ===================================== Table error ============================================================= -->\n<mat-card *ngIf=\"dataSource?.status === 'error'\" fxLayoutAlign=\"center\">\n  <mat-error><!-- TODO should be configured as input prop --> Es ist etwas falsch gelaufen</mat-error>\n</mat-card>\n"
              },] }
  ];
  /** @nocollapse */
  TableContentComponent.ctorParameters = function () { return [
      { type: router.Router },
      { type: router.ActivatedRoute },
      { type: common.Location }
  ]; };
  TableContentComponent.propDecorators = {
      tableLayoutInput: [{ type: core.Input }],
      rowColumnDirectives: [{ type: core.ContentChildren, args: [TableRowColumnDirective,] }],
      hasToolbar: [{ type: core.Input }],
      hasSearch: [{ type: core.Input }],
      hasAddButton: [{ type: core.Input }],
      hasBackButton: [{ type: core.Input }],
      hasPaginator: [{ type: core.Input }],
      tableRowClick: [{ type: core.Output }],
      matSort: [{ type: core.ViewChild, args: [sort.MatSort, { static: true },] }],
      matPaginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: true },] }]
  };

  var TableTitleComponent = /** @class */ (function () {
      function TableTitleComponent() {
      }
      TableTitleComponent.prototype.ngOnInit = function () {
      };
      return TableTitleComponent;
  }());
  TableTitleComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'app-table-title',
                  template: "<p>\n  table-title works!\n</p>\n"
              },] }
  ];
  /** @nocollapse */
  TableTitleComponent.ctorParameters = function () { return []; };

  var TableHeaderComponent = /** @class */ (function () {
      function TableHeaderComponent() {
      }
      TableHeaderComponent.prototype.ngOnInit = function () {
      };
      return TableHeaderComponent;
  }());
  TableHeaderComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'base-table-header',
                  template: "<mat-toolbar fxLayoutGap=\"10px\">\n  <ng-content></ng-content>\n  <div class=\"spacer\"></div>\n</mat-toolbar>\n"
              },] }
  ];
  /** @nocollapse */
  TableHeaderComponent.ctorParameters = function () { return []; };

  var TableLayoutComponent = /** @class */ (function () {
      function TableLayoutComponent() {
          this.status = 'loading';
      }
      TableLayoutComponent.prototype.ngOnInit = function () {
      };
      return TableLayoutComponent;
  }());
  TableLayoutComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'base-table-layout',
                  template: "<div class=\"table-layout mat-elevation-z12\">\n  <ng-content select=\"[content]\"></ng-content>\n</div>\n"
              },] }
  ];
  /** @nocollapse */
  TableLayoutComponent.ctorParameters = function () { return []; };
  TableLayoutComponent.propDecorators = {
      status: [{ type: core.Input }]
  };

  var TableContentResponsiveComponent = /** @class */ (function () {
      function TableContentResponsiveComponent(router, activatedRoute, location) {
          this.router = router;
          this.activatedRoute = activatedRoute;
          this.location = location;
          this.hasToolbar = true;
          this.hasSearch = true;
          this.hasAddButton = true;
          this.hasBackButton = true;
          this.hasPaginator = true;
          this.tableRowClick = new core.EventEmitter();
      }
      Object.defineProperty(TableContentResponsiveComponent.prototype, "tableLayoutInput", {
          get: function () {
              return this._tableLayoutInput;
          },
          set: function (tl) {
              this._tableLayoutInput = tl;
          },
          enumerable: false,
          configurable: true
      });
      Object.defineProperty(TableContentResponsiveComponent.prototype, "matSort", {
          set: function (ms) {
              this.sort = ms;
          },
          enumerable: false,
          configurable: true
      });
      Object.defineProperty(TableContentResponsiveComponent.prototype, "matPaginator", {
          set: function (ms) {
              this.paginator = ms;
          },
          enumerable: false,
          configurable: true
      });
      TableContentResponsiveComponent.prototype.ngOnInit = function () {
          var _this = this;
          this.tableLayoutInput.dataSource.setPaginator(this.paginator);
          this.tableLayoutInput.dataSource.setSort(this.sort);
          this.tableLayoutInput.columnDef.pipe(operators.map(function (res) { return res.map(function (res) { return res.columnId; }); })).subscribe(function (res) {
              _this.displayedColumns = res;
          });
          this.tableLayoutInput.columnDef.pipe(operators.map(function (res) { return res.map(function (res) { return res.columnName; }); })).subscribe(function (res) {
              _this.columnNames = res;
          });
          if (this.tableLayoutInput.addRoute) {
              this.addRoute = this.tableLayoutInput.addRoute;
          }
      };
      TableContentResponsiveComponent.prototype.ngAfterContentInit = function () {
          var columnMap = new Map();
          var refArray = this.rowColumnDirectives.toArray();
          refArray.forEach(function (val) {
              columnMap.set(val.rowColumn, val);
          });
          this.rowColumnTemplates = columnMap;
      };
      TableContentResponsiveComponent.prototype.getPageSizeOptions = function () {
          return [5, 10, 20, 50, 100, 250];
      };
      TableContentResponsiveComponent.prototype.getDefaultPageSize = function () {
          return 250;
      };
      TableContentResponsiveComponent.prototype.add = function () {
          if (this.addRoute) {
              if (this.addRoute.queryParams) {
                  this.router.navigate([this.addRoute.path], { queryParams: this.addRoute.queryParams });
              }
              else {
                  this.router.navigate([this.addRoute.path]);
              }
          }
          else {
              this.router.navigate(['0'], { relativeTo: this.activatedRoute });
          }
      };
      TableContentResponsiveComponent.prototype.onRowClick = function (row) {
          this.tableRowClick.emit(row);
      };
      TableContentResponsiveComponent.prototype.reload = function (filter) {
          this.tableLayoutInput.dataSource.filterSubject.next(filter);
          return false;
      };
      TableContentResponsiveComponent.prototype.navigateBack = function () {
          this.location.back();
      };
      return TableContentResponsiveComponent;
  }());
  TableContentResponsiveComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'base-table-content-responsive',
                  template: "<!-- =================================  Table search + dynamic filter comp + buttons =============================== -->\n<mat-toolbar style=\"height:90px\" class=\"table-layout-toolbar\" *ngIf=\"hasToolbar\">\n\n  <button mat-mini-fab name=\"cmd\" type=\"button\" [routerLink]=\"'..'\" class=\"margin-right--small\" *ngIf=\"hasBackButton\">\n    <mat-icon>arrow_back</mat-icon>\n  </button>\n\n  <ng-container><!-- <ng-container *permissionEdit=\"tableLayoutInput.expectedRoles\">-->\n    <button *ngIf=\"!tableLayoutInput.disableAddButton && hasAddButton\" mat-mini-fab name=\"cmd\" type=\"button\"\n            value=\"create\" (click)=\"add()\" class=\"margin-right--small\">\n      <mat-icon>add</mat-icon>\n    </button>\n  </ng-container>\n\n  <!-- TODO fix the excel export; probably those controls should be injectable via template/ngcontent -->\n<!--  <button *ngIf=\"tableLayoutInput.downloadable\" mat-mini-fab name=\"excel\" type=\"button\"\n          (click)=\"tableLayoutInput.dataSource.excelExport()\" class=\"margin-right&#45;&#45;small\">\n    <mat-icon>cloud_download</mat-icon>\n  </button>-->\n\n<!--  <table-search [searchFields]=\"tableLayoutInput.advanceSearchCriteria\"\n                [hasAdvanceSearch]=\"tableLayoutInput.advanceSearch\" *ngIf=\"tableLayoutInput.searchable && hasSearch\"\n                (changed)=\"reload($event)\"\n                class=\"margin-right&#45;&#45;small\"></table-search>-->\n\n  <div class=\"spacer\"></div>\n\n\n</mat-toolbar>\n\n<!-- =================================   Further table controls (e.g. tabs)========================================= -->\n\n<ng-content select=\"[controls]\"></ng-content>\n\n<!-- =================================   Paginator ================================================================= -->\n<div>\n  <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"getDefaultPageSize()\" [pageSizeOptions]=\"getPageSizeOptions()\">\n  </mat-paginator>\n</div>\n\n<!-- =================================== Mat Table ================================================================= -->\n<div class=\"base-table-responsive\">\n  <mat-table multiTemplateDataRows [dataSource]=\"tableLayoutInput.dataSource\" matSort\n             matSortActive=\"{{tableLayoutInput.matSortActive}}\" matSortDisableClear\n             matSortDirection=\"{{tableLayoutInput.matSortDirection ? tableLayoutInput.matSortDirection : 'desc'}}\"\n             class=\"expandable\">\n\n    <ng-container *ngFor=\"let column of displayedColumns;let i = index\" [matColumnDef]=\"column\">\n\n      <mat-header-cell *matHeaderCellDef mat-sort-header>\n        {{columnNames[i]}}\n      </mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span class=\"resp-row-label\" style=\"float:left; padding:0;\">{{columnNames[i]}}</span>\n        <ng-container [ngTemplateOutlet]=\"rowColumnTemplates.get(column)?.templateRef\"\n                      [ngTemplateOutletContext]=\"{$implicit: row}\"></ng-container>\n      </mat-cell>\n\n    </ng-container>\n\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onRowClick(row)\">\n    </mat-row>\n\n  </mat-table>\n</div>\n\n\n<!-- ===================================== Loading indicator ======================================================= -->\n<mat-card fxLayout=\"row\" *ngIf=\"tableLayoutInput.dataSource.status == 'loading'\" fxLayoutAlign=\"center\">\n<!-- TODO put loading indicator here  <app-loading-indicator></app-loading-indicator>-->\n</mat-card>\n\n\n\n",
                  animations: [
                      animations.trigger('detailExpand', [
                          animations.state('collapsed', animations.style({ height: '0px', minHeight: '0', display: 'none' })),
                          animations.state('expanded', animations.style({ height: '*' })),
                          animations.transition('expanded <=> collapsed', animations.animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
                      ]),
                  ]
              },] }
  ];
  /** @nocollapse */
  TableContentResponsiveComponent.ctorParameters = function () { return [
      { type: router.Router },
      { type: router.ActivatedRoute },
      { type: common.Location }
  ]; };
  TableContentResponsiveComponent.propDecorators = {
      tableLayoutInput: [{ type: core.Input }],
      rowColumnDirectives: [{ type: core.ContentChildren, args: [TableRowColumnDirective,] }],
      hasToolbar: [{ type: core.Input }],
      hasSearch: [{ type: core.Input }],
      hasAddButton: [{ type: core.Input }],
      hasBackButton: [{ type: core.Input }],
      hasPaginator: [{ type: core.Input }],
      tableRowClick: [{ type: core.Output }],
      matSort: [{ type: core.ViewChild, args: [sort.MatSort, { static: true },] }],
      matPaginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: true },] }]
  };

  var TableLayoutModule = /** @class */ (function () {
      function TableLayoutModule() {
      }
      return TableLayoutModule;
  }());
  TableLayoutModule.decorators = [
      { type: core.NgModule, args: [{
                  declarations: [
                      TableRowColumnDirective,
                      TableContentComponent,
                      TableTitleComponent,
                      TableHeaderComponent,
                      TableLayoutComponent,
                      TableContentResponsiveComponent
                  ],
                  imports: [
                      toolbar.MatToolbarModule,
                      icon.MatIconModule,
                      button.MatButtonModule,
                      common.CommonModule,
                      paginator.MatPaginatorModule,
                      table.MatTableModule,
                      sort.MatSortModule,
                      card.MatCardModule,
                      formField.MatFormFieldModule,
                      router.RouterModule,
                  ],
                  exports: [
                      TableRowColumnDirective,
                      TableContentComponent,
                      TableTitleComponent,
                      TableHeaderComponent,
                      TableLayoutComponent,
                      TableContentResponsiveComponent
                  ]
              },] }
  ];

  var LayoutModule = /** @class */ (function () {
      function LayoutModule() {
      }
      return LayoutModule;
  }());
  LayoutModule.decorators = [
      { type: core.NgModule, args: [{
                  declarations: [LayoutComponent],
                  imports: [
                      TableLayoutModule
                  ],
                  exports: [
                      TableLayoutModule
                  ]
              },] }
  ];

  /*
   * Public API Surface of layout
   */

  /**
   * Generated bundle index. Do not edit.
   */

  exports.LayoutModule = LayoutModule;
  exports.TableContentComponent = TableContentComponent;
  exports.TableContentResponsiveComponent = TableContentResponsiveComponent;
  exports.TableHeaderComponent = TableHeaderComponent;
  exports.TableLayoutComponent = TableLayoutComponent;
  exports.TableLayoutModule = TableLayoutModule;
  exports.TableRowColumnDirective = TableRowColumnDirective;
  exports.TableTitleComponent = TableTitleComponent;
  exports.ɵa = LayoutComponent;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-base-angular-layout.umd.js.map
