import { EventEmitter, OnInit, QueryList, TemplateRef } from '@angular/core';
import { ActivatedRoute, Router } from "@angular/router";
import { Location } from '@angular/common';
import { FilteredTableSource } from "@yukawa/chain-base-angular-store";
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { TableFilter } from "@yukawa/chain-base-angular-domain";
import { RouteDesc, TableLayoutInput } from "../types";
export declare class TableRowColumnDirective {
    templateRef: TemplateRef<any>;
    rowColumn: string;
    constructor(templateRef: TemplateRef<any>);
}
export declare class TableContentComponent implements OnInit {
    private router;
    private activatedRoute;
    private location;
    _tableLayoutInput: TableLayoutInput;
    dataSource: FilteredTableSource<any, any>;
    set tableLayoutInput(tl: TableLayoutInput);
    get tableLayoutInput(): TableLayoutInput;
    rowColumnDirectives: QueryList<TableRowColumnDirective>;
    rowColumnTemplates: Map<string, TableRowColumnDirective>;
    hasToolbar: boolean;
    hasSearch: boolean;
    hasAddButton: boolean;
    hasBackButton: boolean;
    hasPaginator: boolean;
    tableRowClick: EventEmitter<any>;
    addRoute: RouteDesc;
    backRoute: RouteDesc;
    private paginator;
    private sort;
    set matSort(ms: MatSort);
    set matPaginator(ms: MatPaginator);
    displayedColumns: String[];
    columnNames: String[];
    constructor(router: Router, activatedRoute: ActivatedRoute, location: Location);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    getPageSizeOptions(): number[];
    getDefaultPageSize(): number;
    add(): void;
    back(): void;
    onRowClick(row: any): void;
    reload(filter: TableFilter | any): boolean;
    navigateBack(): void;
}
