import { FilteredTableSource } from "@yukawa/chain-base-angular-store";
import { Observable } from "rxjs";
import { Validator } from "@angular/forms";
export interface TableLayoutInput {
    dataSource: FilteredTableSource<any, any>;
    pageSizeOptions?: number[];
    matSortActive: string;
    matSortDirection?: string;
    pageSize?: number;
    columnDef: Observable<TableColumn[]>;
    searchable?: boolean;
    downloadable?: boolean;
    disableAddButton?: boolean;
    exitRoute?: string;
    addRoute?: RouteDesc;
    backRoute?: RouteDesc;
    advanceSearch?: boolean;
    advanceSearchCriteria?: FieldConfig[];
    expectedRoles?: string[];
    title?: string;
    paginator?: Paginator;
}
export interface RouteDesc {
    path: string;
    queryParams?: object;
    pathParams?: string[];
}
export interface FieldConfig {
    label?: string;
    name?: string;
    inputType?: string;
    options?: any[];
    collections?: any;
    type: string;
    value?: any;
    proptext?: string;
    propvalue?: string;
    validations?: Validator[];
}
export interface Paginator {
    pageSize: number;
    pageIndex: number;
}
export interface TableColumn {
    columnId: String;
    columnName: String;
}
